﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Utility
{
    /// <summary>
    /// In order to keep consistent with database data. 
    /// </summary>
    public enum RoleFlag : int
    {
        Civilian = 1,
        Killer = 2,
        Police = 4
    }

    public enum ActivityTypeFlag : int
    {
        Vote = 1,
        Kill = 2,
        Investigate = 4
    }

    public enum IsOnlineFlag : int
    {
        Offline = 1,
        Online = 2
    }

    public enum IsActiveFlag : int
    {
        Dead = 1,
        Active = 2
    }

    public enum TimeFlag : int
    {
        DayTime = 0,
        Night = 1
    }
    public enum EnumGameStatus : int 
    {
        Run = 1,
        Wait = 2,
        Dead = 4
    }
}
